/*
** Module   :FNTABLE.CPP
** Abstract :
**
** Copyright (C) Sergey I. Yevtushenko
**
** Log: Mon  08/03/2004	Created
**
*/

#include <boxcoll.h>
#include <version.h>

//-----------------------------------------
// Main dispatcher table
//-----------------------------------------

DispatchEntry dispatch_list[]=
{
    {"abort"            , "fedabort"            , EditBoxCollection::doAbort           },
    {"bksp"             , "fedbksp"             , EditBoxCollection::doBksp            },
    {"close"            , "fedclose"            , EditBoxCollection::doClose           },
    {"copy"             , "fedcopy"             , EditBoxCollection::doCopy            },
    {"copyright"        , "fedcopyright"        , EditBoxCollection::doCopyright2      },
    {"cut"              , "fedcut"              , EditBoxCollection::doCut             },
    {"del"              , "feddel"              , EditBoxCollection::doDel             },
    {"delline"          , "feddelline"          , EditBoxCollection::doDelLine         },
    {"deltoeol"         , "feddeltoeol"         , EditBoxCollection::doDelToEOL        },
    {"delwordleft"      , "feddelwordleft"      , EditBoxCollection::doDelWordLeft     },
    {"delwordright"     , "feddelwordright"     , EditBoxCollection::doDelWordRight    },
    {"down"             , "feddown"             , EditBoxCollection::doDown            },
    {"downmark"         , "feddownmark"         , EditBoxCollection::doDownMark        },
    {"dupline"          , "feddupline"          , EditBoxCollection::doDupLine         },
    {"end"              , "fedend"              , EditBoxCollection::doEnd             },
    {"endmark"          , "fedendmark"          , EditBoxCollection::doEndMark         },
    {"exit"             , "fedexit"             , EditBoxCollection::doExit            },
    {"filebegin"        , "fedfilebegin"        , EditBoxCollection::doFileBegin       },
    {"filebeginmark"    , "fedfilebeginmark"    , EditBoxCollection::doFileBeginMark   },
    {"fileend"          , "fedfileend"          , EditBoxCollection::doFileEnd         },
    {"fileendmark"      , "fedfileendmark"      , EditBoxCollection::doFileEndMark     },
    {"filelist"         , "fedfilelist"         , EditBoxCollection::doFileList        },
    {"filestat"         , "fedfilestat"         , EditBoxCollection::doFileStat        },
    {"flipautoindent"   , "fedflipautoindent"   , EditBoxCollection::doFlipAutoindent  },
    {"flipblockmode"    , "fedflipblockmode"    , EditBoxCollection::doFlipBlockMode   },
    {"fliphiliting"     , "fedfliphiliting"     , EditBoxCollection::doFlipHiliting    },
    {"fliptype"         , "fedfliptype"         , EditBoxCollection::doFlipType        },
    {"flipwordwrap"     , "fedflipwordwrap"     , EditBoxCollection::doFlipWordWrap    },
    {"flipwordwrappara" , "fedflipwordwrappara" , EditBoxCollection::doFlipWWLong      },
    {"flipwordwrapmerge", "fedflipwordwrapmerge", EditBoxCollection::doFlipWWMerge     },
    {"flipcompletion"   , "fedflipcompletion"   , EditBoxCollection::doFlipCompletion  },
    {"helpscreen"       , "fedhelpscreen"       , EditBoxCollection::doHelpScreen      },
    {"hiliteselect"     , "fedhiliteachoice"    , EditBoxCollection::doHilitingChoice  },
    {"home"             , "fedhome"             , EditBoxCollection::doHome            },
    {"homemark"         , "fedhomemark"         , EditBoxCollection::doHomeMark        },
    {"indent"           , "fedindent"           , EditBoxCollection::doIndent          },
    {"ins"              , "fedins"              , EditBoxCollection::doIns             },
    {"insdate"          , "fedinsdate"          , EditBoxCollection::doInsDate         },
    {"insfilename"      , "fedinsfilename"      , EditBoxCollection::doInsFileName     },
    {"insfilenameshort" , "fedinsfilenameshort" , EditBoxCollection::doInsFileNameShort},
    {"jumpcol"          , "fedjumpcol"          , EditBoxCollection::doJumpCol         },
    {"jumpline"         , "fedjumpline"         , EditBoxCollection::doJumpLine        },
    {"left"             , "fedleft"             , EditBoxCollection::doLeft            },
    {"leftmark"         , "fedleftmark"         , EditBoxCollection::doLeftMark        },
    {"load"             , "fedload"             , EditBoxCollection::doLoad            },
    {"bind"             , "fedloadkeys"         , EditBoxCollection::doLoadProfile     },
    {"lower"            , "fedlower"            , EditBoxCollection::doLower           },
    {"markword"         , "fedmarkword"         , EditBoxCollection::doMarkWord        },
    {"macrorecend"      , "fedmacrorecend"      , EditBoxCollection::doMacroRecEnd     },
    {"macrorecstart"    , "fedmacrorecstart"    , EditBoxCollection::doMacroRecStart   },
    {"matchbracket"     , "fedmatchbracket"     , EditBoxCollection::doMatchBracket    },
    {"matchbracketmark" , "fedmatchbracketmark" , EditBoxCollection::doMatchBracketMark},
    {"new"              , "fednew"              , EditBoxCollection::doNew             },
    {"nextfile"         , "fednextfile"         , EditBoxCollection::doNextFile        },
    {"lastfile"         , "fedlastfile"         , EditBoxCollection::doLastFile        },
    {"nextcompletion"   , "fednextcompletion"   , EditBoxCollection::doNextCompletion  },
    {"selectcompletion" , "fedselectcompletion" , EditBoxCollection::doSelectCompletion},
    {"paste"            , "fedpaste"            , EditBoxCollection::doPaste           },
    {"pgdn"             , "fedpgdn"             , EditBoxCollection::doPgDn            },
    {"pgdnmark"         , "fedpgdnmark"         , EditBoxCollection::doPgDnMark        },
    {"pgup"             , "fedpgup"             , EditBoxCollection::doPgUp            },
    {"pgupmark"         , "fedpgupmark"         , EditBoxCollection::doPgUpMark        },
    {"prevfile"         , "fedprevfile"         , EditBoxCollection::doPrevFile        },
    {"right"            , "fedright"            , EditBoxCollection::doRight           },
    {"rightmark"        , "fedrightmark"        , EditBoxCollection::doRightMark       },
    {"save"             , "fedsave"             , EditBoxCollection::doSave            },
    {"saveall"          , "fedsaveall"          , EditBoxCollection::doSaveAll         },
    {"saveas"           , "fedsaveas"           , EditBoxCollection::doSaveAs          },
    {"search"           , "fedsearch"           , EditBoxCollection::doSearch          },
    {"searchagain"      , "fedsearchagain"      , EditBoxCollection::doSearchAgain     },
    {"setcp"            , "fedsetxlat"          , EditBoxCollection::doSetXlat         },
    {"sort"             , "fedsort"             , EditBoxCollection::doSort            },
    {"touchall"         , "fedtouchall"         , EditBoxCollection::doTouchAll        },
    {"undo"             , "fedundo"             , EditBoxCollection::doUndo            },
    {"unindent"         , "fedunindent"         , EditBoxCollection::doUnindent        },
    {"up"               , "fedup"               , EditBoxCollection::doUp              },
    {"upmark"           , "fedupmark"           , EditBoxCollection::doUpMark          },
    {"upper"            , "fedupper"            , EditBoxCollection::doUpper           },
    {"wordleft"         , "fedwordleft"         , EditBoxCollection::doWordLeft        },
    {"wordleftmark"     , "fedwordleftmark"     , EditBoxCollection::doWordLeftMark    },
    {"wordright"        , "fedwordright"        , EditBoxCollection::doWordRight       },
    {"wordrightmark"    , "fedwordrightmark"    , EditBoxCollection::doWordRightMark   },

    {"markgo0"          , 0, EditBoxCollection::doGotoMark},
    {"markgo1"          , 0, EditBoxCollection::doGotoMark},
    {"markgo2"          , 0, EditBoxCollection::doGotoMark},
    {"markgo3"          , 0, EditBoxCollection::doGotoMark},
    {"markgo4"          , 0, EditBoxCollection::doGotoMark},
    {"markgo5"          , 0, EditBoxCollection::doGotoMark},
    {"markgo6"          , 0, EditBoxCollection::doGotoMark},
    {"markgo7"          , 0, EditBoxCollection::doGotoMark},
    {"markgo8"          , 0, EditBoxCollection::doGotoMark},
    {"markgo9"          , 0, EditBoxCollection::doGotoMark},
    {"markset0"         , 0, EditBoxCollection::doSetMark },
    {"markset1"         , 0, EditBoxCollection::doSetMark },
    {"markset2"         , 0, EditBoxCollection::doSetMark },
    {"markset3"         , 0, EditBoxCollection::doSetMark },
    {"markset4"         , 0, EditBoxCollection::doSetMark },
    {"markset5"         , 0, EditBoxCollection::doSetMark },
    {"markset6"         , 0, EditBoxCollection::doSetMark },
    {"markset7"         , 0, EditBoxCollection::doSetMark },
    {"markset8"         , 0, EditBoxCollection::doSetMark },
    {"markset9"         , 0, EditBoxCollection::doSetMark },
    {"openjumplist0"    , 0, EditBoxCollection::doJumpList},
    {"openjumplist1"    , 0, EditBoxCollection::doJumpList},
    {"openjumplist2"    , 0, EditBoxCollection::doJumpList},
    {"openjumplist3"    , 0, EditBoxCollection::doJumpList},
    {"openjumplist4"    , 0, EditBoxCollection::doJumpList},
    {"openjumplist5"    , 0, EditBoxCollection::doJumpList},
    {"openjumplist6"    , 0, EditBoxCollection::doJumpList},
    {"openjumplist7"    , 0, EditBoxCollection::doJumpList},
    {"openjumplist8"    , 0, EditBoxCollection::doJumpList},
    {"openjumplist9"    , 0, EditBoxCollection::doJumpList},
    {"-"                , 0, EditBoxCollection::doRexx    },
};

//-----------------------------------------
// Function disctionary constructor
//-----------------------------------------

void FunctionDictionary::fill_functions(FunctionDictionary* p)
{
    for(int i = 0; i < sizeof(dispatch_list)/sizeof(dispatch_list[0]); i++)
        p->Add(&dispatch_list[i]);
}

void FunctionDictionary::fill_rexx_functions(FunctionDictionary* p)
{
    for(int i = 0; i < sizeof(dispatch_list)/sizeof(dispatch_list[0]); i++)
    {
		if(dispatch_list[i].rx.rxname)
	        p->Add(&dispatch_list[i].rx);
    }
}

